open Logarion
module FS = File_store
module A = Archive

open Cmdliner
let term =
	let recurse = Arg.(value & flag & info ["R"] ~doc:"recurse, include subdirs") in
	let reverse = Arg.(value & flag & info ["r"] ~doc:"reverse order") in
	let paths = Arg.(value & flag & info ["p"] ~doc:"show file paths") in
	let number = Arg.(value & opt (some int) (Some 10) & info ["n"]
		~docv:"number" ~doc:"number of entries to list") in
	let authed = Arg.(value & opt (some string) None & info ["authored"]
		~docv:"comma-separated names" ~doc:"texts by authors") in
	let topics = Arg.(value & opt (some string) None & info ["topics"]
		~docv:"comma-separated topics" ~doc:"texts with topics") in
	let dir  = Arg.(value & pos 0 string "" & info []
		~docv:"directory to index") in
	Term.(const Listing.listing $ recurse $ (const true) $ reverse $ number $ paths $ authed $ topics $ dir),
	Term.info "recent" ~doc:"list recent texts" ~man:[ `S "DESCRIPTION";
		`P "List header information of most recent texts. If -R is used, list header
		information for texts found in subdirectories too, along with their filepaths" ]
